From 95cc9d54052034ae14c346b1f80dcb6a4a243a08 Mon Sep 17 00:00:00 2001
From: Chen Qun <kuhn.chenqun@huawei.com>
Date: Tue, 14 Apr 2020 19:07:45 +0800
Subject: [PATCH 43/77] hotplug_serial: don't need delete virtio-serial
 controller sometime

We don't need delete virtio-serial controller when
'dev.type == "virtio-serial" and dev.index == "0"'.

If we force delete it, it will automatically generate
 PCI number, which may not be used by q35 machine.

Signed-off-by: Chen Qun <kuhn.chenqun@huawei.com>
---
 libvirt/tests/src/hotplug_serial.py | 15 ++++++++++-----
 1 file changed, 10 insertions(+), 5 deletions(-)

diff --git a/libvirt/tests/src/hotplug_serial.py b/libvirt/tests/src/hotplug_serial.py
index 64c8ce20..f69b8242 100644
--- a/libvirt/tests/src/hotplug_serial.py
+++ b/libvirt/tests/src/hotplug_serial.py
@@ -38,13 +38,18 @@ def run(test, params, env):
     # add controller for each char device
     devices = vm_xml.get_devices()
     controllers = vm_xml.get_devices(device_type="controller")
+    virtio_serial_flag = False
     for dev in controllers:
-        if dev.type == "virtio-serial":
+        if dev.type == "virtio-serial" and dev.index == "0":
+            virtio_serial_flag = True
+            continue
+        elif dev.type == "virtio-serial":
             devices.remove(dev)
-    controller = Controller("controller")
-    controller.type = "virtio-serial"
-    controller.index = 0
-    devices.append(controller)
+    if not virtio_serial_flag:
+        controller = Controller("controller")
+        controller.type = "virtio-serial"
+        controller.index = 0
+        devices.append(controller)
     vm_xml.set_devices(devices)
     vm_xml.sync()
 
-- 
2.23.0

